<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN"><HTML><HEAD><TITLE>80386 Programmer's Reference Manual -- Opcode DEC</TITLE> </HEAD><BODY><B>up:</B> <A HREF="c17.htm">Chapter 17 -- 80386 Instruction Set</A><BR><B>prev:</B><A HREF="DAS.htm"> DAS Decimal Adjust AL after Subtraction</A><BR><B>next:</B><A HREF="DIV.htm"> DIV Unsigned Divide</A><P><HR><P><H1>DEC -- Decrement by 1</H1><PRE>
Opcode    Instruction        Clocks   Description

FE /1     DEC r/m8           2/6      Decrement r/m byte by 1
FF /1     DEC r/m16          2/6      Decrement r/m word by 1
          DEC r/m32          2/6      Decrement r/m dword by 1
48+rw     DEC r16            2        Decrement word register by 1
48+rw     DEC r32            2        Decrement dword register by 1
</PRE><H2>Operation</H2><PRE>
DEST := DEST - 1;
</PRE><H2>Description</H2>DEC subtracts 1 from the operand. DEC does not change the carry flag. To affect the carry flag, use the <A HREF="SUB.htm">SUB</A> instruction with an immediate operand of 1.<H2>Flags Affected</H2>OF, SF, ZF, AF, and PF as described in <A HREF="appc.htm">Appendix C</A>.<H2>Protected Mode Exceptions</H2>#GP(0) if the result is a nonwritable segment; #GP(0) for an illegal memory operand effective address in the CS, DS, ES, FS, or GS segments; #SS(0) for an illegal address in the SS segment; #PF(fault-code) for a page fault<H2>Real Address Mode Exceptions</H2>Interrupt 13 if any part of the operand would lie outside of the effective address space from 0 to 0FFFFH<H2>Virtual 8086 Mode Exceptions</H2>Same exceptions as in Real Address Mode; #PF(fault-code) for a page fault<P><HR><P><B>up:</B> <A HREF="c17.htm">Chapter 17 -- 80386 Instruction Set</A><BR><B>prev:</B><A HREF="DAS.htm"> DAS Decimal Adjust AL after Subtraction</A><BR><B>next:</B><A HREF="DIV.htm"> DIV Unsigned Divide</A> </BODY>